# Generated by rust2rpm 24
%bcond_without check
%global debug_package %{nil}

%global crate pyo3-ffi

Name:           rust-%{crate}-0.17
Version:        0.17.3
Release:        3%{?dist}.1
Summary:        Python-API bindings for the PyO3 ecosystem

License:        Apache-2.0
URL:            https://crates.io/crates/pyo3-ffi
Source:         https://crates.io/api/v1/crates/%crate/%version/download#/%crate-%version.crate
# This patch is applied conditionally if Python has version < 3.10
Source1:        pyo3-ffi-remove-py310.patch
# Manually created patch for downstream crate metadata changes
# * drop MSVC- and MinGW-only features
Patch:          pyo3-ffi-fix-metadata.diff

BuildRequires:  cargo-rpm-macros

%global _description %{expand:
Python-API bindings for the PyO3 ecosystem.}

%description %{_description}

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch
Requires:       python3-devel >= 3.7

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+abi3-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+abi3-devel %{_description}

This package contains library source intended for building other packages which
use the "abi3" feature of the "%{crate}" crate.

%files       -n %{name}+abi3-devel
%ghost %{crate_instdir}/Cargo.toml

%if 0%{?fedora} >= 35
%package     -n %{name}+abi3-py310-devel
Summary:        %{summary}
BuildArch:      noarch
Requires:       python3-devel >= 3.10

%description -n %{name}+abi3-py310-devel %{_description}

This package contains library source intended for building other packages which
use the "abi3-py310" feature of the "%{crate}" crate.

%files       -n %{name}+abi3-py310-devel
%ghost %{crate_instdir}/Cargo.toml
%endif

%package     -n %{name}+abi3-py37-devel
Summary:        %{summary}
BuildArch:      noarch
Requires:       python3-devel >= 3.7

%description -n %{name}+abi3-py37-devel %{_description}

This package contains library source intended for building other packages which
use the "abi3-py37" feature of the "%{crate}" crate.

%files       -n %{name}+abi3-py37-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+abi3-py38-devel
Summary:        %{summary}
BuildArch:      noarch
Requires:       python3-devel >= 3.8

%description -n %{name}+abi3-py38-devel %{_description}

This package contains library source intended for building other packages which
use the "abi3-py38" feature of the "%{crate}" crate.

%files       -n %{name}+abi3-py38-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+abi3-py39-devel
Summary:        %{summary}
BuildArch:      noarch
Requires:       python3-devel >= 3.9

%description -n %{name}+abi3-py39-devel %{_description}

This package contains library source intended for building other packages which
use the "abi3-py39" feature of the "%{crate}" crate.

%files       -n %{name}+abi3-py39-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+extension-module-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+extension-module-devel %{_description}

This package contains library source intended for building other packages which
use the "extension-module" feature of the "%{crate}" crate.

%files       -n %{name}+extension-module-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
# Remove abi3-py310 feature if we build for old Fedora or not Fedora
%if 0%{?fedora} < 35
patch -p1 < %{SOURCE1}
%endif
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires
echo 'python3-devel >= 3.7'

%build
%cargo_build

%install
%cargo_install

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Mon Apr 10 2023 Oleg Girko <ol@infoserver.lv> - 0.17.3-3
- Remove abi3-py310 feature if Python is older than 3.10
* Mon Apr 10 2023 Oleg Girko <ol@infoserver.lv> - 0.17.3-2
- Drop MSVC- and MinGW-only features
* Mon Apr 10 2023 Oleg Girko <ol@infoserver.lv> - 0.17.3-1
- Initial package
